#include "Utils.h"

template<class A, class B>
struct DeleteMapFntor
{
    // Overloaded () operator.
    // This will be called by for_each() function.
    bool operator()(pair<A,B> x) const
    {
        // Assuming the second item of map is to be
        // deleted. Change as you wish.
        delete x.second;
        return true;
    }
};


struct Log
{
	char* name;
	double time;
	double TIME;
	bool load;
	int on;
	void SetName(const char* nname)
	{
		on = 0;
		load = true;
		name = new char[strlen(nname)+1];
		for(int i = 0; i < strlen(nname);i++)
		  name[i] = nname[i];
	}
};

map<int,Log*> logmap;	

void SaveTime()
{
	FILE* f = fopen("logmap.txt","w");
	fprintf(f,"Gesamtzeit: %f\n%-20s | %-20s | %-20s | %-20s | %-20s\n",(float)clock()/1000.0,"Name","Aufrufe","Zeit pro Aufruf","Gesamtzeit","%");
	fprintf(f,"-------------------------------------------------------------------------------------------------------\n");
	double gst = 0;
	double ons = 0;
	double gstpa = 0;
	for(std::map<int,Log*>::iterator i = logmap.begin();i!=logmap.end();++i)
	{
		ons += (*i).second->on;
		gst += (*i).second->TIME;
		gstpa += (*i).second->TIME/(*i).second->on;
	}
	for(std::map<int,Log*>::iterator i = logmap.begin();i!=logmap.end();++i)
		fprintf(f,"%-20s | %-20i | %-20f | %-20f | %-20f\n",(*i).second->name,(*i).second->on,(*i).second->TIME/(*i).second->on,(*i).second->TIME,(*i).second->TIME/gst*100);
	fprintf(f,"-------------------------------------------------------------------------------------------------------\n");
	fprintf(f,"%-20s | %-20f | %-20f | %-20f | %-20s\n","Gesamt",ons,gstpa,gst,"100");
	float len = logmap.size();
	fprintf(f,"%-20s | %-20f | %-20f | %-20f | %-20f\n","Durchschnitt",ons/len,gstpa/len,gst/len,(float)100/len);
	fclose(f);
	for_each( logmap.begin(),
              logmap.end(),
              DeleteMapFntor<int,Log*>());

}

void LogTime(int id, const char* function)
{	
	Log* l = logmap[id];
	if(!l)
	{
		l = new Log();
		l->SetName(function);
		l->time = (double)clock() / CLOCKS_PER_SEC;
		logmap[id] = l;
	}
	else
	{
		if(l->load)
		{
			l->TIME +=  ((double)clock() / CLOCKS_PER_SEC) - l->time;
		}
		else
		{
			l->time = (double)clock() / CLOCKS_PER_SEC;
		}
		l->load = !l->load;
	}
	++l->on;
}
